import std/options
import std/strformat
import lib/msp430

proc main() =
  let di = newMsp430(1, 0x4f)
  let di_stat_opt = di.get_di_status()
  if di_stat_opt.isSome:
    echo &"* DI Value: {di_stat_opt.get()}"
  let di_pol_opt = di.get_di_polarity()
  if di_pol_opt.isSome:
    echo &"* DI Polarity: {di_pol_opt.get()}"
  for idx in countUp(0, 4):
    let enable_opt = di.get_counter_onoff(idx)
    if not enable_opt.isSome:
      continue
    let enable = enable_opt.get()
    if enable:
      echo &"* DI[{idx}] Counter is enable."
    else:
      let res = di.onoff_counter(idx, true)
      echo &"* DI[{idx}] Counter: set enable -> result: {res}"
    let val_opt = di.get_counter_val(idx)
    if val_opt.isSome:
      let val = val_opt.get()
      echo &"* DI[{idx}] Counter Value: 0x{val:02x}"


when isMainModule:
  main()
